#!/usr/bin/env bash

# This file is part of AWS Cloud,
# a framework to perform massively parallel verification using AWS:
# https://gitlab.com/sosy-lab/sv-comp/aws-cloud
#
# SPDX-FileCopyrightText: 2020 Dirk Beyer <https://www.sosy-lab.org>
#
# SPDX-License-Identifier: Apache-2.0

# The content of this file will be copied into a function inside the job.sh that is then run in the container.

# Variables:
MAIN_BUCKET_NAME="!!MainBucketName!!"
JOB_ID="!!JobId!!"
TASKS_ARCHIVE_S3_KEY="!!TasksArchiveS3Key!!"
VERIFIER_ARCHIVE_S3_KEY="!!VerifierArchiveS3Key!!"
RESULT_FOLDER="!!ResultFolder!!"
LOGFILE_NAME="!!LogfileName!!"
WORKING_DIR="!!WorkingDir!!"
CMDLINE="!!CMDLine!!"

WALLTIME_LIMIT=900 # time in seconds

# unused variables
# - VerifierArchiveUrl:   !!VerifierArchiveUrl!!
# - TasksArchiveUrl:      !!TasksArchiveUrl!!

# setup, download, unpack tasks and verifier
RUN_DIR=$HOME/run
GENERATED_FILES_DIR=/output/upper/${USER}/run
AWS_BATCH_STATUS_CODE_FILE=/tmp/batch-status-code
mkdir -p $RUN_DIR
if [[ ${AWS_BATCH_JOB_MAIN_NODE_INDEX} -eq ${AWS_BATCH_JOB_NODE_INDEX} ]]; then
  aws s3 cp s3://${MAIN_BUCKET_NAME}/${TASKS_ARCHIVE_S3_KEY} ${RUN_DIR}/tasks.zip
  aws s3 cp s3://${MAIN_BUCKET_NAME}/${VERIFIER_ARCHIVE_S3_KEY} ${RUN_DIR}/verifier.zip
  echo 0 > $AWS_BATCH_STATUS_CODE_FILE
else
  while ssh -o StrictHostKeyChecking=accept-new "$USER@${AWS_BATCH_JOB_MAIN_NODE_PRIVATE_IPV4_ADDRESS}" [[ ! -f "${AWS_BATCH_STATUS_CODE_FILE}" ]]; do
    sleep 3
  done
  scp -r "$USER@${AWS_BATCH_JOB_MAIN_NODE_PRIVATE_IPV4_ADDRESS}:${RUN_DIR}/verifier.zip" ${RUN_DIR}/verifier.zip
  scp -r "$USER@${AWS_BATCH_JOB_MAIN_NODE_PRIVATE_IPV4_ADDRESS}:${RUN_DIR}/tasks.zip" ${RUN_DIR}/tasks.zip
fi
chown -R $USER:$USER $RUN_DIR
su -c "unzip -q -d $RUN_DIR ${RUN_DIR}/tasks.zip" $USER
su -c "unzip -q -d $RUN_DIR ${RUN_DIR}/verifier.zip" $USER

ip=$(/sbin/ip -o -4 addr list eth0 | awk '{print $4}' | cut -d/ -f1)
cp /etc/hosts /tmp/hosts.new
sed -i "1s/^/$ip $USER localhost\n/" /tmp/hosts.new
cat /tmp/hosts.new > /etc/hosts
cat /etc/hosts

source ./mpi-run.sh

cd $HOME

if [[ ${AWS_BATCH_JOB_MAIN_NODE_INDEX} -eq ${AWS_BATCH_JOB_NODE_INDEX} ]]
    then
        # Set up an overlay dir such that every generated file by the verifier
        # can afterwards be found in /output/upper
        mkdir /output
        mount none /output -t tmpfs -o "size=100%"
        mkdir /output/upper
        mkdir /output/work
        cd /
        mount none /home -t overlay -o lowerdir=/home,upperdir=/output/upper,workdir=/output/work
        cd $RUN_DIR/$WORKING_DIR

        # Running RunExec using the following options:
        # --read-only-dir /, because in AWS Batch the kernel does not allow overlayfs
        # --network-access, to allow communcation between the different VMs
        # --keep-system-config, as otherwise the container config disables DNS, thus
        #   leading to failing host lookups
        # --full-access-dir ., to allow tools to write into their own directory
        /bin/su -c "runexec --output outputfile.log --walltimelimit ${WALLTIME_LIMIT} --network-access --keep-system-config --full-access-dir /home --read-only-dir / --hidden-dir /output -- ${CMDLINE}" ${USER} >> ${RUN_DIR}/output.log

       # add additional debug info to the logging file
       echo "aws_s3_main_bucket_name=${MAIN_BUCKET_NAME}" >> ${RUN_DIR}/output.log
       echo "aws_job_id=${JOB_ID}" >> ${RUN_DIR}/output.log
       echo "aws_result_folder=${RESULT_FOLDER}" >> ${RUN_DIR}/output.log

       wget http://169.254.169.254/latest/meta-data/instance-type
       echo "aws_instance_type=$(cat ./instance-type)" >> ${RUN_DIR}/output.log
       rm ./instance-type
       echo "aws_instance_os=$(uname -s) $(uname -r)" >> ${RUN_DIR}/output.log
       echo "aws_instance_memory=$(free -b | awk '/Mem/ {print $2}')" >> ${RUN_DIR}/output.log
       echo "aws_instance_cpu_name=$(lscpu | awk '/Model name/ {$1=""; $2=""; print}')" >> ${RUN_DIR}/output.log
       echo "aws_instance_frequency=$(lshw -c cpu | awk '/capacity/ {print $2}')" >> ${RUN_DIR}/output.log
       echo "aws_instance_cores=$(lscpu | awk '/^CPU\(s\)/ {print $2}')" >> ${RUN_DIR}/output.log

       cd /
       umount /home

       # collect results generated by BenchExec
       cd $RUN_DIR
       mkdir ${RESULT_FOLDER}

       if [[ -f ${GENERATED_FILES_DIR}/output.log ]] ; then
           mv ${GENERATED_FILES_DIR}/output.log ${RESULT_FOLDER}/${LOGFILE_NAME}.log.data
       fi

       if [[ -f ${GENERATED_FILES_DIR}/${WORKING_DIR}/outputfile.log ]] ; then
           mv ${GENERATED_FILES_DIR}/${WORKING_DIR}/outputfile.log ${RESULT_FOLDER}/${LOGFILE_NAME}.log
       fi

       # collect result files from the verifier if there are any
       if ls -1qA ${GENERATED_FILES_DIR} | grep -q . ; then
           mkdir ${RESULT_FOLDER}/${LOGFILE_NAME}.files
           mv ${GENERATED_FILES_DIR}/* ${RESULT_FOLDER}/${LOGFILE_NAME}.files
       fi

       cd ${RESULT_FOLDER}
       zip -r ${RESULT_FOLDER}.zip ${LOGFILE_NAME}.log ${LOGFILE_NAME}.log.data ${LOGFILE_NAME}.files

       # upload to S3
       aws s3 cp ${RESULT_FOLDER}.zip s3://${MAIN_BUCKET_NAME}/jobs/${JOB_ID}/results/${RESULT_FOLDER}.zip --acl public-read
       AWS_BATCH_EXIT_CODE_FILE=/tmp/batch-exit-code\
       echo $AWS_BATCH_EXIT_CODE_FILE
       echo 0 > $AWS_BATCH_EXIT_CODE_FILE
fi

# stop supervisord
kill  $(cat /tmp/supervisord.pid)
